#include <stdio.h>
#include <assert.h>
#include <malloc.h>
#include <string.h>
#ifndef TRUE
#define FALSE 0
#define TRUE (!FALSE)
#endif
/*generate all permutations for lists of 1-9 items*/

static int
is_pos_mobile(char *perm, char *arrow, int pos, int n)
{
	if(arrow[pos]=='L' && pos==0)
		return FALSE;
	else if(arrow[pos]=='R' && pos==n-1)
		return FALSE;
	else if(arrow[pos]=='L' && perm[pos]>perm[pos-1])
		return TRUE;
	else if(arrow[pos]=='R' && perm[pos]>perm[pos+1])
		return TRUE;
	else
		return FALSE;
}

static int
get_highest_mobile(char *perm,char *arrow,int n)
{
	int highest = -1;
	int i;
	for(i=0;i<n;i++) {
		if(is_pos_mobile(perm,arrow,i,n) &&
		   (highest == -1 || perm[highest]<perm[i]))
			highest = i;
	}
	return highest;
}

static void
move_pos(char *perm, char *arrow, int pos, int n)
{
	if(arrow[pos]=='L') {
		char t;
		assert(pos>0);
		t = perm[pos];
		perm[pos]=perm[pos-1];
		perm[pos-1]=t;
		t = arrow[pos];
		arrow[pos]=arrow[pos-1];
		arrow[pos-1]=t;
	} else {
		char t;
		assert(pos<n-1);
		t = perm[pos];
		perm[pos]=perm[pos+1];
		perm[pos+1]=t;
		t = arrow[pos];
		arrow[pos]=arrow[pos+1];
		arrow[pos+1]=t;
	}
}

static void
switch_all_above(char *perm, char *arrow, int pos, int n)
{
	int i;
	for(i=0;i<n;i++) {
		if(perm[i]>perm[pos]) {
			if(arrow[i]=='L')
				arrow[i]='R';
			else
				arrow[i]='L';
		}
	}
}

int
main(void)
{
	char *perm;
	char *arrow;
	int n,i;
	int cols,col=0;
	printf("Enter number of items(1-9): ");
	scanf("%d",&n);
	if(n<=0) return 0;
	if(n>9) return 0;
	printf("Enter number of columns to print(1-10): ");
	scanf("%d",&cols);
	if(cols<=0) return 0;
	if(cols>10) return 0;
	arrow = malloc(n+1);
	perm = malloc(n+1);
	for(i=0;i<n;i++) perm[i]='1'+i;
	perm[i]='\0';
	for(i=0;i<n;i++) arrow[i]='L';
	for(;;) {
		int m;
		if(col==0)
			printf("%s",perm);
		else
			printf("\t%s",perm);
		if((++col)==cols) {
			putc('\n',stdout);
			col = 0;
		}
		m = get_highest_mobile(perm,arrow,n);
		if(m==-1) break;
		switch_all_above(perm,arrow,m,n);
		move_pos(perm,arrow,m,n);
	}
	if(col>0)
		putc('\n',stdout);
	return 0;
}
